
## Before running this file open base.xls in Excel

   **************************************************************************
[Tutorial 1]
   **************************************************************************

#RoadID="xa"

edit,tutorial
031,  |RoadID|
031,mz
031,0
999

copy,alignments,tutorial
060,g0xa
999
edit,tutorial
029,g0xa,7=5
   trimming the ends to speed up execution
005,3=m0xa,8=11000
005,3=m0xa,5=21900
999

#xs=getpoint("tutorial","m0xa",+1,num,4)
#xe=getpoint("tutorial","m0xa",-1,num,4)
#xs100=int(xs/100)*100+100
#xe100=int((xe-0.001)/100)*100

edit,tutorial
027,m0xa,regu,m1xa,|xs100|,|xs100|,,100,|xe100|
999

#offsnorm=1.8
desi,tutorial
100,m0xa,,tlxa,0,7=|-offsnorm|
100,m0xa,,trxa,0,7=|+offsnorm|
999

insert,[_MedianWidening]
repeat=single
5,3.00,"inner",370
6,2.60,"inner"
end

desi,tutorial
100,m0xa,tlxa,bxxa, 0.025,7= 0.50
100,m0xa,tlxa,plxa,-0.025,7=-7.50
100,m0xa,plxa,blxa,-0.025,7=-0.25
100,m0xa,blxa,llxa,-0.025,7=-2.75
100,m0xa,llxa,klxa,-0.050,7=-1.00

100,m0xa,trxa,byxa, 0.025,7=-0.50
100,m0xa,trxa,prxa,-0.025,7= 7.50
100,m0xa,prxa,brxa,-0.025,7= 0.25
100,m0xa,brxa,lrxa,-0.025,7= 2.75
100,m0xa,lrxa,krxa,-0.050,7= 1.00
999

   No superelevation now

insert,[_Subgrade].

insert,MedianCrossing
repeat=single
11200,,"^"
13000,,"v"
15000,,"v"
18000,,"v"
end

   A trick to display chainage by styleset

dele,x
crea,x
edit,tutorial
031,m2xa
999
copy,tutorial,x
060,m1xa
999
edit,x
020,m1xa,,m2xa
999
copy,x,tutorial
060,m2xa
999
dele,x

   Tidy up

edit,tutorial
031,  0
999
comp,modelfile








[_MedianWidening]

## To ensure sufficient sight distance
## the median strip has to be widened in certain curves.
## This extra horizontal offset should be calculated
## previously or can be calculated by InputPlus if available.

## Calling this macro list the values below

## f1 - nth curve (use REPO/980,2=HCEN to check the number of curves)
## f2 - widening in meters
## f3 - "inner"/"outer" (which pivot axis to be amended)
## f4 - length of changeover before the curve if not equals to the transition length (optional)
## f5 - length of changeover  after the curve if not equals to the transition length (optional)

default
subr="",labl="xat",cf=0

option

repeat

##    centers into buffer
repo,tutorial
980,g0xa,hcen
999

##    center and radii of current (f1) curve
#xc=getdata(f1,num,2)
#yc=getdata(f1,num,3)
#R=getdata(f1,num,4)

##    (storing variable 'repeat' because a nested repetitive macro follows)
#stored_repeat=repeat

##    tangent points into buffer
repo,tutorial
980,g0xa,htps
999

##    finds the Horizontal Tangent Point
##    which distance from center P(xc;yc) is R.
insert,[_SearchCurve]
repeat=getdata(1,num,15)

if f4<>"" then ch1=ch2-f4
if f5<>"" then ch4=ch3+f5
if ch1=ch2 then ch1=0
if ch4=ch3 then ch4=0

##    (retrieving variable 'repeat')
#repeat=stored_repeat

if f3="outer" then inout=-1 else inout=+1
#bool=sgn(R)*inout
if bool=-1 then slr="l" else slr="r"

#onorm=bool*offsnorm
#oplus=bool*(offsnorm+f2)

##    if the first or last curve was supplied the relating option is omitted
#des2=||
if ch1=0 then des1="000" else des1=||
if ch4=0 then des3="000" else des3=||

desi,tutorial
|des1|102,m0xa,,t|slr|xa,0,|ch1|,,|onorm|,|ch2|,,|oplus|
|des2|100,m0xa,,t|slr|xa,0,|ch2|,,|oplus|,|ch3|
|des3|102,m0xa,,t|slr|xa,0,|ch3|,,|oplus|,|ch4|,,|onorm|
999

endrepeat





[_SearchCurve]

## 'count' is a built-in variable. It counts the loops.
## 'repeat' is also built-in. If its value is "end" then
## quits the loop and all the remaining loops are skipped.

option

repeat

#xi=getdata(count,num,2)
#yi=getdata(count,num,3)
#dist=sqr((xi-xc)^2+(yi-yc)^2)

if abs(abs(R)-dist)<0.001 then found=count,repeat="end"

endrepeat

## Now we have the HTPS at the beginning of the curve.
## The four chainages can be retrieved.
## Remember the last REPO command. The results are still in the buffer.
## ch1 - beginning of transition
## ch2 - beginning of curve
## ch3 - end of curve
## ch4 - end of transition

#ch1=getdata(found-1,num,5)
#ch2=getdata(found+0,num,5)
#ch3=getdata(found+1,num,5)
#ch4=getdata(found+2,num,5)





[_Subgrade]

default
mast="m0xa",id="xa"

option

#sg1=getname("base.xls","subgrade",1,"MW")
#sg2=getname("base.xls","subgrade",2,"MW")

desi,tutorial
110,|mast|,ll|id|,hb|id|,|-sg1|,7= 0.01
110,|mast|,bl|id|,hl|id|,|-sg1|,7=-0.01
110,|mast|,bl|id|,hm|id|,|-sg1|,7= 0.01
110,|mast|,bx|id|,ht|id|,|-sg1|,7=-0.01

110,|mast|,by|id|,hu|id|,|-sg1|,7= 0.01
110,|mast|,br|id|,hn|id|,|-sg1|,7=-0.01
110,|mast|,br|id|,hr|id|,|-sg1|,7= 0.01
110,|mast|,lr|id|,hj|id|,|-sg1|,7=-0.01

110,|mast|,ll|id|,ib|id|,|-sg2|,7=0
110,|mast|,bl|id|,im|id|,|-sg2|,7=0
110,|mast|,bx|id|,iv|id|,|-sg2|,7=0

110,|mast|,by|id|,iw|id|,|-sg2|,7=0
110,|mast|,br|id|,in|id|,|-sg2|,7=0
110,|mast|,lr|id|,ij|id|,|-sg2|,7=0

103,|mast|,,ix|id|
104,,im|id|,iv|id|,0,7=|sg2|
103,|mast|,,iy|id|
104,,in|id|,iw|id|,0,7=|-sg2|

100,|mast|,ll|id|,it|id|,7=|-sg2|
134,|mast|,,it|id|
104,,im|id|,ib|id|

100,|mast|,lr|id|,iu|id|,7=|sg2|
134,|mast|,,iu|id|
104,,in|id|,ij|id|
999

